<?php
/**
 * @copyright	Copyright (C) 2009-2012 ACYBA SARL - All rights reserved.
 * @license		http://www.gnu.org/licenses/gpl-3.0.html GNU/GPL
 */
defined('_JEXEC') or die('Restricted access');

class plgHikashopAttachinvoice extends JPlugin
{

	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
	}

	function _getPDFInvoice($orderIds = array()){

		$app = JFactory::getApplication();

		if(!class_exists('HTML2PDF')) include(dirname(__FILE__).DS.'attachinvoice'.DS.'html2pdf.class.php');

		$config =& hikashop_config();
		$class = hikashop_get('class.order');
		$currencyHelper = hikashop_get('class.currency');
		$fields = array();
		$null = null;
		$fieldsClass = hikashop_get('class.field');
		$fields['item'] = $fieldsClass->getFields('backend_listing',$null,'item');

		//This array stores all pdf pages...
		$pdfContent = array();

		foreach($orderIds as $orderId){
			$order = $class->loadFullOrder($orderId,true,false);
			$fields['order'] = $fieldsClass->getFields('backend',$order,'order');
			ob_start();
			if(file_exists(HIKASHOP_MEDIA.'plugins'.DS.'invoice.php')){
				$file = HIKASHOP_MEDIA.'plugins'.DS.'invoice.php';
			}else{
				$file = dirname(__FILE__).DS.'attachinvoice'.DS.'invoice.php';
			}
			require($file);
			$pdfContent[] = ob_get_clean();
		}

		$content = implode('<div style="page-break-before:always"></div>',$pdfContent);
		$content = hikashop_absoluteURL($content);

		//$html2pdf = new HTML2PDF('P', 'A4', 'en');
		$html2pdf = new HTML2PDF('P', 'A4', 'en',true, 'UTF-8');
		$font =	$this->params->get('font');
		if(!empty($font)){
			$html2pdf->setDefaultFont($font);
		}
		$html2pdf->pdf->SetDisplayMode('fullpage');
		$html2pdf->writeHTML($content);
		$fileName = JText::_('INVOICE');
		if(count($orderIds) == 1) $fileName.= '_'.reset($orderIds);
		$html2pdf->Output($fileName.'.pdf','D');

		exit;
	}

	//When task is triggered...
	function onHikaShopBeforeDisplayView(&$view){

		$ctrl = @$view->ctrl;
		$task = $view->getLayout();

		//Add invoice button on all orders page... or not :(
		$app = JFactory::getApplication();
		if($ctrl == "order" && $task == 'listing' && $app->isAdmin()){
			// JToolBarHelper::custom('triggerplug-generateinvoice', 'preview', '',JText::_('INVOICE'));
			$bar = JToolBar::getInstance('toolbar');
			$icon	= preg_replace('#\.[^.]*$#', '', 'preview');
			$bar->prependButton( 'Standard', $icon, JText::_('INVOICE'), 'triggerplug-generateinvoice', true, false);
			return;
		}

		//Generate invoice for front-end and back-end!
		if($ctrl == 'order' && $task == 'invoice' && $app->isAdmin() && JRequest::getString('type') != 'shipping'){
			$this->_getPDFInvoice(array(JRequest::getInt('order_id')));
			return;
		}

		if($ctrl == 'order' && $task == 'show' && !$app->isAdmin() && JRequest::getCmd('task') == 'invoice'){
			$this->_getPDFInvoice(array(JRequest::getInt('order_id')));
			return;
		}

	}

	function onAfterRender(){
		//We avoid the popup effect on some buttons we modified...
		$app = JFactory::getApplication();
		if($app->isAdmin() && JRequest::getCmd('option') == 'com_hikashop' && JRequest::getCmd('ctrl') == 'order' && JRequest::getCmd('task') == 'edit'){
			$body = JResponse::getBody();
			$body = preg_replace('#class="modal"([^>]*type=full)#Uis','$1',$body,1);
			JResponse::setBody($body);
		}

		if(!$app->isAdmin() && JRequest::getCmd('option') == 'com_hikashop' && JRequest::getCmd('ctrl') == 'order' && JRequest::getCmd('task') == 'show'){
			$body = JResponse::getBody();
			$body = preg_replace('#(id="hikashop_order_print_button"[^>]*)class="modal"#Uis','$1',$body,1);
			JResponse::setBody($body);
		}

	}

	function onTriggerPlugGenerateinvoice(){
		//It should be only from the backend...
		$app = JFactory::getApplication();
		if(!$app->isAdmin()) exit;

		$cids = JRequest::getVar( 'cid', array(), '', 'array' );
		//Action if I add a button triggerplug-generateinvoice
		$this->_getPDFInvoice($cids);

	}

	function onBeforeMailSend(&$data,&$mailer){

		//We only add the invoice to confirmed orders... and for the status notification e-mail only!
		$config =& hikashop_config();
		$confirmed = $config->get('order_confirmed_status','confirmed');
		//  !!!!!!!!!!!!!!!!!!!      if(empty($data->mail_name) || empty($data->data->order_status) || !in_array($data->mail_name,array('order_status_notification','order_creation_notification')) || $data->data->order_status != $confirmed) return;				if(empty($data->mail_name) || empty($data->data->order_status) || !in_array($data->mail_name,array('order_status_notification','order_creation_notification'))) return;

		if(!class_exists('HTML2PDF')) include(dirname(__FILE__).DS.'attachinvoice'.DS.'html2pdf.class.php');

		$orderId = $data->data->order_id;
		/*
		if(!isset($data->data->order_invoice_number)) {
			return;
		}
		*/

		$invoiceFolder = dirname(__FILE__).DS.'attachinvoice'.DS.'invoices';
		//We add the time to the pdf so we won't delete pdf files if they were created less than two minutes ago
		//Just to avoid a pdf to be deleted during the send process
		$invoiceFile = JText::_('INVOICE').'-'.$orderId.'_'.time().'.pdf';

		//Automatically delete old invoices before generating an other one.
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');
		$allInvoices = JFolder::files($invoiceFolder,'.*pdf');
		//Just in case of two invoices are sent at the same time...
		$oldInvoicesTime = time() - 120;
		if(!empty($allInvoices)){
			foreach($allInvoices as $oneInvoice){
				list($stuff,$time) = explode('_',$oneInvoice);
				//We don't delete it if it has been created less than 2 minutes ago
				if($time > $oldInvoicesTime) continue;
				JFile::delete($invoiceFolder.DS.$oneInvoice);
			}
		}

		$app = JFactory::getApplication();

		$config =& hikashop_config();
		$class = hikashop_get('class.order');
		$order = $class->loadFullOrder($orderId,true,false);
		$currencyHelper = hikashop_get('class.currency');
		$fields = array();
		$null = null;
		$fieldsClass = hikashop_get('class.field');
		$fields['item'] = $fieldsClass->getFields('backend_listing',$null,'item');
		$fields['order'] = $fieldsClass->getFields('backend',$order,'order');

		ob_start();
		if(file_exists(HIKASHOP_MEDIA.'plugins'.DS.'invoice.php')){
			$file = HIKASHOP_MEDIA.'plugins'.DS.'invoice.php';
		}else{
			$file = dirname(__FILE__).DS.'attachinvoice'.DS.'invoice.php';
		}
		require($file);
		$content = ob_get_clean();
		$content=hikashop_absoluteURL($content);
		try{
			//$html2pdf = new HTML2PDF('P', 'A4', 'en');

			$html2pdf = new HTML2PDF('P', 'A4', 'en',true, 'UTF-8');
			$font =	$this->params->get('font');
			if(!empty($font)){
				$html2pdf->setDefaultFont($font);
			}
			$html2pdf->pdf->SetDisplayMode('fullpage');

			$html2pdf->writeHTML($content);
			$html2pdf->Output($invoiceFolder.DS.$invoiceFile, 'F');

			//Ok let's add the invoice to the mail now! The path is $invoiceFolder.DS.'invoice_'.$order->order_id.'.pdf
			//STUPID J1.5 which does not let me access the phpMailer library directly and does not handle the name parameter for the attachment... GRRR
			$mailer->AddAttachment($invoiceFolder.DS.$invoiceFile,JText::_('INVOICE').'.pdf');
		}catch(HTML2PDF_exception $e) {
			//IF ADMIN WE ENQUEUE THE ERROR MESSAGE...
			if($app->isAdmin()){
				$app->enqueueMessage($e,'error');
			}
		}

		//We add an BCC in case of the parameters say so...
		$cc = $this->params->get('copy');
		if(!empty($cc)){
			$mailer->AddBCC($cc);
		}
	 }

}//endclass